Subject: Re: [Technical Errata Reported] RFC7540 (4663)

From: <[email-masked]>
Date: Tue, 12 Apr 2016 18:10:08 +0000

It breaks the CGI interface, which per RFC 3875 is expecting the SERVER_PROTOCOL variable to contain "HTTP/2.0", not "HTTP/2".  It may also break any server log analysis tools which depend on the ANBF syntax as the variable may also appear in the logs.

RFC 3875, Section 4.1.16 ABNF:

   HTTP-Version      = "HTTP" "/" 1*digit "." 1*digit

The "minor" number is not optional.  If this has been changed, RFC 7540 needs to say so.  It doesn't.

Personally, I don't care if this is handled via an errata or another RFC which clarifies the conflict.

--------------------------------------------
On Tue, 4/12/16, Barry Leiba <[email-masked]> wrote:
I don't understand how it breaks anything: when you use HTTP/1.1, you have the minor version.  When you use HTTP/2, you're using a server that understands HTTP/2 and knows what to expect.  Please explain where the problem occurs.
...

---

From: Willy Tarreau <[email-masked]>
Date: Thu, 14 Apr 2016 23:22:21 +0200

On Tue, Apr 12, 2016 at 06:10:08PM +0000, [email-masked] wrote:
> It breaks the CGI interface, which per RFC 3875 is expecting the
> SERVER_PROTOCOL variable to contain "HTTP/2.0", not "HTTP/2".  It may also
> break any server log analysis tools which depend on the ANBF syntax as the
> variable may also appear in the logs.
> 

But Barry and Mark explained to you that there is no such version conveyed
by the protocol and that the version you're seeing in your variable is
written this way by the server. In other words, while in HTTP/1 the server
could have copied the field from the request, in HTTP/2 it has to invent
that field by itself since it's not present.

Thus the server should simply respect the specification of the protocol it
is speaking. If CGI has a spec, the server should simply follow this spec.
But it's totally unrelated to the HTTP spec. If your server wants to pass
IMAP requests over a CGI interface, it may very well decide to write
IMAP/1 and you would complain to the server's implementation, not to the
IMAP protocol spec authors.

This whole request doesn't make any sense.

Willy